unit ProcTypU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls;

type
  TfmExample = class(TForm)
    Panel1: TPanel;
    bbRun: TBitBtn;
    bbClose: TBitBtn;
    edInput: TEdit;
    lbOutput: TLabel;
    mmOutput: TMemo;
    procedure bbRunClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmExample: TfmExample;

implementation

{$R *.dfm}
Function Sin1(X: Real): Real;
begin
  Result := (Sin(X) + 1) * Exp(-X)
end;          // Sin1

Function Cos1(X: Real): Real; 
begin
  Result := (Cos(X) + 1) * Exp(-X)
end;          // Cos1

procedure TfmExample.bbRunClick(Sender: TObject);
type
  Func = function (X: Real): Real;      //  
Procedure PrintFunc(NP: Integer; F: Func) ;
var
  k: Integer;
  X: Real;
begin
  for k := 0 to NP do
  begin
    X := k * 2 * pi / NP;
    mmOutput.Lines.Add(FloatToStrF(X, ffExponent, 10, 2) + 
#9#9 + FloatToStrF(F(X), ffExponent, 10, 2));
  end;
end;         // PrintFunc

begin 		// bbRunClick
  mmOutput.Lines.Add(#9' SIN1:');
  PrintFunc(10, Sin1);
  mmOutput.Lines.Add(#9' COS1:');
  PrintFunc(10, Cos1);
end;

end.
