unit Cmplx;
//---------------------------------------------
                 Interface
//---------------------------------------------
type
  Complex = record
              re,im: real
            end;

Function AddC (x,y: Complex): Complex;
Function SubC (x,y: Complex): Complex;
Function MulC (x,y: Complex): Complex;
Function DivC (x,y: Complex): Complex;

const
  c : Complex = (re : 0.1; im : -1);
//---------------------------------------------
                Implementation
//---------------------------------------------
Function AddC (x,y: Complex): Complex;
//   
begin
  Result.re := x.re + y.re;
  Result.im := x.im + y.im
end; //AddC

Function SubC (x,y: Complex): Complex;
//   
begin
  Result.re := x.re - y.re;
  Result.im := x.im - y.im
end; //SubC

Function MulC (x,y: Complex): Complex;
//   
begin
  Result.re := x.re * y.re - x.im * y.im;
  Result.im := x.re * y.im + x.im * y.re
end; //MulC

Function DivC (x,y: Complex): Complex;
//   
var
  z: Real;
begin
  z := sqr(y.re) + sqr(y.im);
  //      ,  z=0:
  try
    Result.re := (x.re * y.re + x.im * y.im) / z;
    Result.im := (x.re * y.im - x.im * y.re) / z;
  except
    Result.re := 1.1e309;
    Result.im := 1.1e309;
  end
end {DivC};

end.
 