unit PenU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls;

type
  TfmExample = class(TForm)
    Panel1: TPanel;
    bbRun: TBitBtn;
    bbClose: TBitBtn;
    lbOutput: TLabel;
    pbOut: TPaintBox;
    pbPen: TPaintBox;
    Splitter1: TSplitter;
    cbPen: TColorBox;
    cbBack: TColorBox;
    cbMode: TComboBox;
    bbPen: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure bbRunClick(Sender: TObject);
    procedure bbPenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmExample: TfmExample;

implementation

{$R *.dfm}

procedure TfmExample.bbRunClick(Sender: TObject);
var
  k: Integer;
const
  Names: array [0..6] of String[30]= ('psSolid', 'psDash', 'psDot', 'psDashDot',
                'psDashDotDot', 'psClear', 'psInsideFrame');
begin
  // 7   :
  with pbOut.Canvas, Pen do
  begin
    for k := 0 to 6 do
    begin
      Style := TPenStyle(k);        //  
      MoveTo(10, k*25+10);          //    
      LineTo(350, k*25+10);         // 
      TextOut(360, k*25+5, Names[k])//  
    end
  end;
  lbOutput.Caption := '    ,  Mode     ""';
end;

const //16     Mode
  PenMode: array [0..15] of string[13]=('pmBlack', 'pmWhite', 'pmNop', 'pmNot',
  'pmCopy', 'pmNotCopy', 'pmMergePenNot', 'pmMaskPenNot', 'pmMergeNotPen',
  'pmMaskNotPen', 'pmMerge', 'pmNotMrege', 'pmMask', 'pmNotMask', 'pmXOR',
  'pmNotWor');

procedure TfmExample.bbPenClick(Sender: TObject);
var
  X, Y, L: Integer;
begin
  with pbPen.Canvas do
  begin
    Pen.Width := 5;
    // :
    Brush.Color := cbBack.Colors[cbBack.ItemIndex];
    FillRect(ClipRect);
    //    :
    Pen.Color := cbPen.Colors[cbPen.ItemIndex];
    Pen.Mode := TPenMode(cbMode.ItemIndex);
    //    pbPen   :
    X := 10;
    Y := ClipRect.Bottom div 2;
    L := ClipRect.Right-10;
    MoveTo(X, Y);
    LineTo(L, Y)
  end
end;

procedure TfmExample.FormCreate(Sender: TObject);
//  cbMode    
var
  k: Integer;
begin
  cbMode.Items.Clear;
  for k := 0 to 15 do
    cbMode.Items.Add(PenMode[k])
end;

end.
