unit DrawGridMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids;

type
  TfmDrawGrid = class(TForm)
    dgDraw: TDrawGrid;
    procedure FormCreate(Sender: TObject);
    procedure dgDrawGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure dgDrawSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure dgDrawDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormResize(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    slBitMap: TStringList;
  end;

var
  fmDrawGrid: TfmDrawGrid;

implementation

{$R *.DFM}

procedure TfmDrawGrid.FormCreate(Sender: TObject);
//     slBitMap
const
  Bmp_Path = 'C:\Program Files\Common Files\Borland Shared\'+
		'Images\Splash\16Color\';
  FNames: array [0..3] of String = {   }
  ('athena.bmp', 'construc.bmp', 'earth.bmp', 'technlgy.bmp');
var
  k: Integer;
begin
  //   :
  slBitMap := TStringList.Create;
  //       :
  with slBitMap do for k := 0 to 3 do
  begin
    Add(FNames[k]);
    Objects[k] := TBitMap.Create;
    (Objects[k] as TBitMap).LoadFromFile(Bmp_Path+FNames[k])
  end
end;

procedure TfmDrawGrid.dgDrawGetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: String);
//     
begin
  Value := slBitMap[2 * ACol + Arow]
end;

procedure TfmDrawGrid.dgDrawSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
//         slBitMap
begin
  slBitMap[2 * ACol + ARow] := Value
end;

procedure TfmDrawGrid.dgDrawDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
//    slBitMap.Objects    slBitMap
var
  k: Integer;
begin
  //      :
  k := 2 * ACol + ARow;
  with dgDraw.Canvas, Rect, slBitMap do
  begin
    //        :
    Bottom := Bottom - TextHeight('1') - 2;
    //  :
    StretchDraw(Rect, (Objects[k] as TBitMap));
    //       :
    TextOut(Left+(Right-Left-TextWidth(slBitMap[k])) div 2,
                 Bottom + 1, slBitMap[k])
  end
end;

procedure TfmDrawGrid.FormResize(Sender: TObject);
//       .
//        
// 
begin
  with dgDraw do
  begin
    DefaultColWidth := ClientRect.Right div 2 - 1;
    DefaultRowHeight := ClientRect.Bottom div 2 - 1
  end;
end;

procedure TfmDrawGrid.FormDeactivate(Sender: TObject);
begin
  slBitMap.Free
end;

end.
