unit RichEdU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdActns, ExtActns, ActnList, Menus, ImgList, ComCtrls, ToolWin,
  StdCtrls, Buttons, Spin, ExtCtrls;

type
  TForm1 = class(TForm)
    ToolbarImages: TImageList;
    MainMenu1: TMainMenu;
    ActionList1: TActionList;
    FileSaveAs1: TFileSaveAs;
    FilePrintSetup1: TFilePrintSetup;
    FileExit1: TFileExit;
    Action2: TAction;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    EditSelectAll1: TEditSelectAll;
    EditUndo1: TEditUndo;
    EditDelete1: TEditDelete;
    Action11: TMenuItem;
    N1: TMenuItem;
    FileNew: TAction;
    N2: TMenuItem;
    FileSave: TAction;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    Undo1: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    ToolBar1: TToolBar;
    Editor: TRichEdit;
    StatusBar1: TStatusBar;
    ToolButton4: TToolButton;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    tbNew: TToolButton;
    tbOpen: TToolButton;
    tbSave: TToolButton;
    tbPrint: TToolButton;
    ToolButton8: TToolButton;
    tbUndo: TToolButton;
    tbCopy: TToolButton;
    tbCut: TToolButton;
    tbPaste: TToolButton;
    ToolButton13: TToolButton;
    cbFont: TComboBox;
    seSize: TSpinEdit;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    tbBold: TToolButton;
    tbItalic: TToolButton;
    tbUnderline: TToolButton;
    ToolButton19: TToolButton;
    tbLeft: TToolButton;
    tbCenter: TToolButton;
    tbRight: TToolButton;
    ToolButton23: TToolButton;
    tbMark: TToolButton;
    pnRuler: TPanel;
    bvRuler: TBevel;
    lbInd: TLabel;
    lbLeft: TLabel;
    lbRight: TLabel;
    SaveDialog1: TSaveDialog;
    PrintDialog1: TPrintDialog;
    FilePrint: TAction;
    OpenDialog1: TOpenDialog;
    FileOpen: TAction;
    procedure FileNewExecute(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure lbRightMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lbRightMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure lbRightMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cbFontChange(Sender: TObject);
    procedure seSizeChange(Sender: TObject);
    procedure AlignBtnClick(Sender: TObject);
    procedure tbMarkClick(Sender: TObject);
    procedure tbItalicClick(Sender: TObject);
    procedure tbBoldClick(Sender: TObject);
    procedure tbUnderlineClick(Sender: TObject);
    procedure FilePrintExecute(Sender: TObject);
    procedure FileSaveExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FileOpenExecute(Sender: TObject);
    procedure N14Click(Sender: TObject);
  private
    { Private declarations }
    FFileName: String;  // 
    FDragging: Boolean; //    
    FDragOfs: Integer;  //    
    procedure GetFontNames;
    procedure SetupRuler;
    procedure SetupBounds;
    function CurrentText: TTExtAttributes;
    procedure UpdateSettings;
    function CheckChangeFile: Boolean;
    procedure SetFileName(const FileName: String);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses About;

{$R *.dfm}

const
  Untitled = '';

{       }
function EnumFontsProc(var LogFont: TLogFont; var TextMetric: TTextMetric;
  FontType: Integer; Data: Pointer): Integer; stdcall;
begin
  {  Data  TSrings    }
  TStrings(Data).Add(LogFont.lfFaceName);
  Result := 1; //  
end;

procedure TForm1.SetFileName(const FileName: String);
//      
begin
  FFileName := FileName;
  Caption := Format('%s - %s', [ExtractFileName(FileName), Application.Title]);
end;

procedure TForm1.GetFontNames;
//    
var
  DC: HDC; // . 
begin
  DC := GetDC(0); //     . EnumFonts
  EnumFonts(DC, nil, @EnumFontsProc, Pointer(cbFont.Items));
  ReleaseDC(0, DC);  //  
  cbFont.Sorted := True; //   
end;

procedure TForm1.SetupRuler;
//   
var
  I: Integer;
  S: String;
begin
  SetLength(S, 51);
  I := 1;
  while I < 50 do
  begin
    S[I] := #9;    //  Tab
    S[I+1] := '|'; // 
    Inc(I, 2);
  end;
  pnRuler.Caption := S;
end;

procedure TForm1.FormActivate(Sender: TObject);
//  .      -
//  Tag     0,    
var
  k: Integer;
begin
  if Tag = 0 then      // ?
  begin                //-
    Tag := 1;          //  
    SetupRuler;        //  
    GetFontNames;      //   
    SetupBounds;       //  
    FormResize(Self);  //     
    for k := 0 to cbFont.Items.Count-1 do    //     
    if cbFont.Items[k]=Editor.Font.Name then
      break;
    cbFont.ItemIndex := k;                   //      
    seSize.Value := Editor.Font.Size;        //  
    //        (ParamStr(0)
    //          )
    OpenDialog1.InitialDir := ExtractFilePath(ParamStr(0));
    SaveDialog1.InitialDir := OpenDialog1.InitialDir;
    Editor.Modified := False;
    FileNewExecute(Self)   //   
  end
end;

procedure TForm1.FileNewExecute(Sender: TObject);
// 
begin
  if CheckChangeFile then
  begin
    SetFileName(Untitled);
    Editor.Lines.Clear;
    Editor.Modified := False;
    Editor.SetFocus
  end
end;

procedure TForm1.FormResize(Sender: TObject);
//      
begin
  bvRuler.Width := pnRuler.Width-20;
end;

{       .
     lbFirst, lbLeft, lbRight,
    .     
      Windings.  ""    
 ,  "" -  .      
   .    
  lbRight    .}

procedure TForm1.SetupBounds;
//  
const
  BoundsCoeff = 0.75;   {     , 
        FirstIndent, LeftIndent,
  RightIndent  3/4 }
begin
  with Editor,Paragraph do
  begin
    FirstIndent := Round(lbInd.Left*BoundsCoeff);
    RightIndent := Round((ClientWidth-lbRight.Left-lbRight.Width div 2)*BoundsCoeff);
    LeftIndent := Round(lbLeft.Left*BoundsCoeff)-FirstIndent
  end
end;

procedure TForm1.lbRightMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//   - 
begin
  FDragging := True;
  FDragOfs := TLabel(Sender).Width div 2;
  TLabel(Sender).Left := TLabel(Sender).Left+X-FDragOfs;
end;

procedure TForm1.lbRightMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
// -
begin
  if FDragging then
    TLabel(Sender).Left := TLabel(Sender).Left+X-FDragOfs;
end;

procedure TForm1.lbRightMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//  -
begin
  FDragging := False;
  SetupBounds
end;

function TForm1.CurrentText: TTExtAttributes;
//   ,     -  
begin
  if Editor.SelLength > 0 then
    Result := Editor.SelAttributes
  else
    Result := Editor.DefAttributes
end;

procedure TForm1.UpdateSettings;
//    ( )   
//    
begin
  //  
  tbBold.Down := fsBold in CurrentText.Style;
  tbItalic.Down := fsItalic in CurrentText.Style;
  tbUnderline.Down := fsUnderLine in CurrentText.Style;
  //     
  tbLeft.Down := Editor.Paragraph.Alignment=taLeftJustify;
  tbCenter.Down := Editor.Paragraph.Alignment=taCenter;
  tbRight.Down := Editor.Paragraph.Alignment=taRightJustify;
  tbMark.Down :=Editor.Paragraph.Numbering=nsBullet;
end;

procedure TForm1.cbFontChange(Sender: TObject);
//  
begin
  with Editor do
  if SelLength > 0 then
    SelAttributes.Name := cbFont.Text
  else
    DefAttributes.Name := cbFont.Text;
  UpdateSettings
end;

procedure TForm1.seSizeChange(Sender: TObject);
//  
begin
  if seSize.Value>0 then
    CurrentText.Size := seSize.Value;
  UpdateSettings
end;

procedure TForm1.AlignBtnClick(Sender: TObject);
//       ( Tag 
//     )
begin
  Editor.Paragraph.Alignment := TAlignment(TControl(Sender).Tag);
  UpdateSettings
end;

procedure TForm1.tbMarkClick(Sender: TObject);
//    
begin
  if Editor.Paragraph.Numbering = nsNone then
    Editor.Paragraph.Numbering := nsBullet
  else
    Editor.Paragraph.Numbering := nsNone;
  UpdateSettings
end;

procedure TForm1.tbItalicClick(Sender: TObject);
//  
begin
  if tbItalic.Down then
    CurrentText.Style := CurrentText.Style + [fsItalic]
  else
    CurrentText.Style := CurrentText.Style - [fsItalic]
end;

procedure TForm1.tbBoldClick(Sender: TObject);
//  
begin
  if tbBold.Down then
    CurrentText.Style := CurrentText.Style + [fsBold]
  else
    CurrentText.Style := CurrentText.Style - [fsBold]
end;

procedure TForm1.tbUnderlineClick(Sender: TObject);
//  
begin
  if tbUnderline.Down then
    CurrentText.Style := CurrentText.Style + [fsUnderline]
  else
    CurrentText.Style := CurrentText.Style - [fsUnderline]
end;

procedure TForm1.FilePrintExecute(Sender: TObject);
// 
begin
  if PrintDialog1.Execute then
    Editor.Print('')
end;

procedure TForm1.FileSaveExecute(Sender: TObject);
//   
label l1;
begin
  if (FFileName <> Untitled) then
l1:
  try
    Editor.Lines.SaveToFile(FFileName);
  except
    ShowMessage('   !')
  end else if SaveDialog1.Execute then
  begin
    SetFileName(SaveDialog1.FileName);
    goto l1
  end
end;

function TForm1.CheckChangeFile: Boolean;
//      
begin
  Result := False;
  if Editor.Modified then
    case MessageDlg(Format(' %S  .  ? ',[FFileName]),
        mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
        mrYes: if FFileName = Untitled then
               begin
                 SaveDialog1.FileName := Untitled;
                 if SaveDialog1.Execute then
                 try
                   Editor.Lines.SaveToFile(SaveDialog1.FileName);
                   Result := True
                 except
                   ShowMessage('  !')
                 end
               end else
               try
                 Editor.Lines.SaveToFile(FFileName);
                 Result := True
               except
                 ShowMessage('  !')
               end;
        mrNo:  Result := True;
        mrCancel: ;
    end else
      Result := True
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
//      
begin
   CanClose := CheckChangeFile
end;

procedure TForm1.FileOpenExecute(Sender: TObject);
// 
begin
  if CheckChangeFile and OpenDialog1.Execute then
  begin
    Editor.Lines.Clear;
    Editor.Lines.LoadFromFile(OpenDialog1.FileName);
    Editor.Modified := False;
    SetFileName(OpenDialog1.FileName);
    Editor.SetFocus
  end
end;

procedure TForm1.N14Click(Sender: TObject);
//  " "
begin
  AboutBox.ShowModal
end;

end.
