unit ThreadU;

interface

uses
  Classes;

type
  ThreadDemo = class(TThread)
  private
    { Private declarations }
  protected
    S: String;
    N: Integer;
    procedure UpdateMemo;
    procedure UpdateGauge;
    procedure Execute; override;
  end;

var
  TDemo: ThreadDemo;

implementation

uses Unit1, SysUtils;

{ Important: Methods and properties of objects in VCL can only be used in a
  method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure ThreadDemo.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ ThreadDemo }

procedure ThreadDemo.Execute;
var
  j,k: Integer;
begin
  repeat
    S := '';
//    Synchronize(UpdateMemo);  //   Synchronize 
    UpdateMemo;                 //    
    for k := 0 to 99 do
    begin
      N := k;
      S := '';
      for j := 1 to 20 do
        S := S+FormatFloat('00',k);
      Synchronize(UpdateMemo);
//      UpdateMemo;
      Synchronize(UpdateGauge);
//      UpdateGauge      
    end;
  until False
end;

procedure ThreadDemo.UpdateGauge;
begin
  with Form1.mmOutput.Lines do
    if (S='') or (Count>1000) then
      Clear
    else
      Add(S)
end;

procedure ThreadDemo.UpdateMemo;
begin
  Form1.Gauge1.Progress := N
end;

end.
 