library Cmplx;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Classes;

{$R *.RES}

type
  TComplex = record
    Re, Im: Real;
  end;

function AddC(x, y: TComplex): TComplex; stdcall;
begin
  Result.Im := x.Im + y.Im;
  Result.Re := x.Re + y.Re
end;

function SubC(x, y: TComplex): TComplex; stdcall;
begin
 Result.Im := x.Im - y.Im;
 Result.Re := x.Re - y.Re
end;

function MulC(x, y: TComplex): TComplex; stdcall;
begin
 Result.Re := x.Re * y.Re + x.Im * y.Im;
 Result.Im := x.Re * y.Im - x.Im * y.Re
end;

function DivC(x, y: TComplex): TComplex; stdcall;
var
  z: Real;
begin
 z := sqr(y.Re) + sqr(y.Im);
 Result.Re := (x.Re * y.Re + x.Im * y.Im)/z;
 Result.Im := (x.Re * y.Im - x.Im * y.Re)/z
end;

Exports
  AddC index 1 name 'ADDC' resident,
  SubC index 2,
  MulC index 3,
  DivC index 4;
begin
end.

