unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TfmExample = class(TForm)
    Panel1: TPanel;
    bbRun: TBitBtn;
    bbClose: TBitBtn;
    edInput: TEdit;
    lbOutput: TLabel;
    mmOutput: TMemo;
    procedure bbRunClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmExample: TfmExample;

implementation

{$R *.DFM}

type
  TComplex = record
    Re, Im: Real;
  end;
  TComplexFunc = function (x, y: TComplex): TComplex; stdcall;

procedure TfmExample.bbRunClick(Sender: TObject);
var
  x,y,z: TComplex;
  AddC,SubC,MulC,DivC: TComplexFunc;
  Handle: LongWord;

procedure Output(Operation: Char);
//        mmOutput
var
  S: String;
begin
  case Operation of
  '+': z := AddC(x,y);
  '-': z := SubC(x,y);
  '*': z := MulC(x,y);
  '/': z := DivC(x,y);
  end;
  S := '('+FormatFloat('+0.0000;-0.0000',x.re)+
          FormatFloat('+0.0000j;-0.0000j',x.im)+')'+Operation+
       '('+FormatFloat('+0.0000;-0.0000',y.re)+
           FormatFloat('+0.0000j;-0.0000j',y.im)+'='+
           FormatFloat('+0.0000;-0.0000',z.re)+
           FormatFloat('+0.0000j;-0.0000j',x.im);
  mmOutput.Lines.Add(S);
end;  //Output

begin  //bbRunClick
  //   CMPLX.DLL
  Handle := LoadLibrary('Cmplx.dll');
  if Handle = 0 then
    begin
      ShowMessage('   CMPLX.DLL');
      Halt
    end;
{  .     ,  
 .       PChar  
,    :}
  @AddC  := GetProcAddress(Handle,PChar(LongInt(1)));
  @SubC  := GetProcAddress(Handle,PChar(LongInt(2)));
  @MulC  := GetProcAddress(Handle,PChar(LongInt(3)));
  @DivC := GetProcAddress(Handle,'DivC');

  x.re := Random;
  x.im := Random;
  y.re := Random;
  y.im := Random;
  Output('+');
  Output('-');
  Output('*');
  Output('/');
  mmOutput.Lines.Add('');
  //  
  FreeLibrary(Handle)
end;

end.
